'***********************************************************************************
'
'   RS232 Monitor (Anzeige der Daten die über die RS232 empfangen werden)
'
'***********************************************************************************
{{
    COG     OBJ     Treiber             Beschreibung
    1       main    -                   Hauptschleife
    2       vga     VGA_2               Textanzeige
    1       RS232   TFullDuplexSerial   1x Seriell
    4       -       -                   frei

    2012.04.04 PIC18F2550       erstellen des Grundgerüstes
}}
CON '-------------------------------------------------------------------------------
    _CLKMODE    = XTAL1 + PLL16X
    _XINFREQ    = 5_000_000

    Baud        = 9600
    TX_Pin     = 30         '
    RX_Pin     = 31         '

    digits     = 2

OBJ '-------------------------------------------------------------------------------
    VGA     : "VGA_2.spin"
    RS232   : "TFullDuplexSerial"
    str     : "ASCII0_STREngine"

VAR '-------------------------------------------------------------------------------
    byte DATAIN[256]

PUB main    | z, s, zei, t   ' Hauptschleife
'***********************************************************************************
    zei := -1
    t   :=  0
    vga.start(16) 'start vga text driver 128x64
    RS232.Start( RX_Pin, TX_Pin, Baud)
    vga.pr_chr($E)
    vga.pr_str(string(" ******************", $A))
    vga.pr_str(string(" * Monitor v. 0.1 *", $A))
    vga.pr_str(string(" * (c) PIC18F2550 *", $A))
    vga.pr_str(string(" ******************", $A, $A))
    repeat
        repeat until (RS232.receiverEmpty == true)
            t := 1
            zei++
            DATAIN[zei] := RS232.readByte

        repeat z from 0 to 15
            repeat s from 0 to 15
                if zei < 0
                    vga.pr_strat(0*2+5,1, string("No Data"))
                if t == 1
                    vga.pr_strat(0*2+5,1, string("       "))
                    t := 2
                if z*16+s =< zei
                    vga.pr_strat(z*2+5,s*5+5, str.integerToHexadecimal(DATAIN[z*16+s],2))
                    vga.pr_strat(z*2+5,s*5+7, string("H"))
                if zei > 255
                    vga.pr_strat(16*2+5,1, string("Limmit"))

